#include<iostream>
#include<set>
#include<string>
#define endl '\n'
using namespace std;
const long long mod=1000000009;
const long long base=31;
long long h,st[100005],p[100005],begi=1,m[100005];
set <string> u;
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
    cin>>s;

    string a;
    long long n;
    cin>>n;

    for(int i=1;i<=n;i++)
    {
        cin>>a;
        u.insert(a);
    }
    int p=0;
    for(int i=0;i<s.size();i++)
    {
        p=0;
       for(int j=i;j<s.size();j++)
       {
           if(u.count(s.substr(i,j-i+1)))
           {
               m[i]++;
               m[j+1]--;p=j;
               break;
           }
       }if(p!=0) i=p;
    }
    long long t=0;
    for(int i=0;i<s.size();i++)
    {
        t+=m[i];//cout<<i<<" "<<t<<endl;
        if(t==0) cout<<s[i];
    }
    cout<<endl;
}
